// -*- C++ -*-
// $Header: /u/drspeech/repos/quicknet2/QN_ListStreamHTK.h,v 1.2 2014/05/06 02:06:46 davidj Exp $

// QN_ListStreamHTK.h 
// This is a class derived from QN_ListStream that can be used for
// implementing a list of HTK feature files.

#ifndef QN_ListStreamHTK_h_INCLUDED
#define QN_ListStreamHTK_h_INCLUDED

#include <stdio.h>
#include "QN_ListStream.h"
#include "QN_HTKstream.h"

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// QN_InFtrStream_ListHTK - a class for stream input from
//                          a list of HTK files.
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
class QN_InFtrStream_ListHTK : public QN_InFtrStream_List
{
public:
    QN_InFtrStream_ListHTK(int a_debug, const char* a_dbgname, FILE* a_file,
			   int a_indexed);
    ~QN_InFtrStream_ListHTK();
    size_t read_ftrs(size_t count, float* ftrs);

protected:
    // This function implements the virtual function defined in
    // QN_InFtrStream_List. It returns -1 on failure. Also, it sets the
    // following base-class variables: 
    //   frames_this_seg 
    //   frame_bytes 
    // It assumes that the name of the file to read will is stored in
    // the base-class variable 'curr_filename'.  Also, it will
    // close any previously opened stream and file.
    void open_ftrfile();

private:
    QN_InFtrStream_HTK1 *feat_stream; // HTK feature stream
    FILE *fp;			// file pointer for the feat stream

};

////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
// QN_InFtrStream_ListSCP - base class for stream input from
//                          a list of files including id, start and end frames.
////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////
class QN_InFtrStream_ListSCP : public QN_InFtrStream_List
{
public:
    QN_InFtrStream_ListSCP(int a_debug, const char* a_dbgname, FILE* a_file,
			   int a_indexed);
    ~QN_InFtrStream_ListSCP();
    size_t read_ftrs(size_t count, float* ftrs);

protected:
    // This function implements the virtual function defined in
    // QN_InFtrStream_List. It returns -1 on failure. Also, it sets the
    // following base-class variables: 
    //   frames_this_seg 
    //   frame_bytes 
    // It assumes that the name of the file to read will is stored in
    // the base-class variable 'curr_filename'.  Also, it will
    // close any previously opened stream and file.
    void open_ftrfile();

private:
    QN_InFtrStream_HTK1 *feat_stream; // Individual HTK feature stream
    FILE *fp;			      // file pointer for the feat stream

};

#endif // #ifdef QN_ListStreamHTK_h_INCLUDED

